/*
	NoScope Credits Bonus, enjoy...
*/

#include <sourcemod>
#include <shop>


#pragma semicolon 1
#pragma newdecls required


int g_iPrice;
int g_iSellPrice;
int g_iGoldPrice;
int g_iGoldSellPrice;
int g_iDuration;
int g_iNoScopeValue;
int g_iHSNoScopeValue;
int g_iMinPlayers;

bool g_bIsOn[MAXPLAYERS+1];
bool g_bMultiCredits;

ItemId id;

static char g_szFeature[] = "bnoscope";

public Plugin myinfo =
{
    name = "[SHOP] NoScope Battle",
    author = "Skeriiz",
	description = "Дает возможность нафармить кредов за Noscope убийства",
    version = "1.1",
    url = "git.com/Skeriiz"
};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max){
	MarkNativeAsOptional("Shop_SetItemGoldPrice");
	MarkNativeAsOptional("Shop_SetItemGoldSellPrice");
	return APLRes_Success;
}

public void OnPluginStart(){
	HookEvent("player_death", Event_PlayerDeath);
	if (Shop_IsStarted()) Shop_Started();
	
	AutoExecConfig(true, "shop_bnoscope", "shop");
}

public void OnPluginEnd()	
	{	Shop_UnregisterMe();	}
public void OnClientDisconnect(int client)
	{	g_bIsOn[client] = false;	}
public void Shop_Started(){
	CategoryId category_id = Shop_RegisterCategory("ability", "Способности", "");
	if (Shop_StartItem(category_id, g_szFeature)){
		
		ConVar cvar;
		(cvar = CreateConVar("sm_shop_noscope_price", "1000", "Noscope Battle цена покупки", 0)).AddChangeHook(OnPrice_Change);
		g_iPrice = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_sellprice", "500", "Noscope Battle цена продажи", 0)).AddChangeHook(OnSell_Change);
		g_iSellPrice = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_gold_price", "50", "Noscope Battle Gold цена покупки", 0)).AddChangeHook(OnPriceG_Change);
		g_iGoldPrice = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_gold_sellprice", "10", "Noscope Battle Gold цена продажи", 0)).AddChangeHook(OnSellG_Change);
		g_iGoldSellPrice = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_duration", "0", "Noscope Battle длительность", 0, true, 0.0)).AddChangeHook(OnDuration_Change);
		g_iDuration = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_value", "0", "Количество кредитов за убийство Noscope", 0, true, 0.0)).AddChangeHook(OnNS_Change);
		g_iNoScopeValue = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscopehs_value", "0", "Количество кредитов за убийство Noscope + HS", 0, true, 0.0)).AddChangeHook(OnNSHS_Change);
		g_iHSNoScopeValue = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_minplayers", "0", "Минимум игроков для работы", 0, true, 0.0)).AddChangeHook(OnMinP_Change);
		g_iMinPlayers = cvar.IntValue;
		(cvar = CreateConVar("sm_shop_noscope_enablemulticr", "1", "Взаимодействовать с CreditsMultiplier", 0, true, 0.0, true, 1.0)).AddChangeHook(OnMultiCR_Change);
		g_bMultiCredits = cvar.BoolValue;
	
		Shop_SetInfo("NoScope Битва", "Позволяет нафармить кредитов за Noscope & NS+HS убийства", g_iPrice, \
		g_iSellPrice, Item_Togglable, g_iDuration, g_iGoldPrice, g_iGoldSellPrice);
		Shop_SetCallbacks(OnItemRegistered, OnEquipItem, _, _, _, _, _, OnSell);
		Shop_EndItem();
	}
}
public void OnItemRegistered(CategoryId category_id, const char[] sCategory, const char[] sItem, ItemId item_id)
	{	id = item_id;	}
public void OnPrice_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iPrice = cv.IntValue;
	if(id != INVALID_ITEM)
		Shop_SetItemPrice(id, cv.IntValue);
}
public void OnSell_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iSellPrice = cv.IntValue;
	if(id != INVALID_ITEM)
		Shop_SetItemSellPrice(id, cv.IntValue);
}
public void OnPriceG_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iGoldPrice = cv.IntValue;
	if(id != INVALID_ITEM)
		Shop_SetItemGoldPrice(id, cv.IntValue);
}
public void OnSellG_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iGoldSellPrice = cv.IntValue;
	if(id != INVALID_ITEM)
		Shop_SetItemGoldSellPrice(id, cv.IntValue);
}
public void OnDuration_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iDuration = cv.IntValue;
}
public void OnNS_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iNoScopeValue = cv.IntValue;
}
public void OnNSHS_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iHSNoScopeValue = cv.IntValue;
}
public void OnMinP_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_iMinPlayers = cv.IntValue;
}
public void OnMultiCR_Change(ConVar cv, const char[] oldV, const char[] newV){
	g_bMultiCredits = cv.BoolValue;
}

public ShopAction OnEquipItem(int client, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, bool isOn, bool elapsed){
	if (isOn || elapsed){
		g_bIsOn[client] = false;
		return Shop_UseOff;
	}

	g_bIsOn[client] = true;
	return Shop_UseOn;
}
public bool OnSell(int client, CategoryId category_id, const char[] category, ItemId item_id, const char[] item, ItemType type, int sell_price, int gold_sell_price){
	OnClientDisconnect(client);
	return true;
}

public void Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast){
	int client = GetClientOfUserId(event.GetInt("userid"));
	int attacker = GetClientOfUserId(event.GetInt("attacker"));
	
	if(ValidPlayer(client) && ValidPlayer(attacker) && g_bIsOn[attacker]
	&& GetClientCount(true) >= g_iMinPlayers)
	{

		char weapon[32];
		GetEventString(event, "weapon", weapon, sizeof(weapon));
		if (!GetEntProp(attacker, Prop_Send, "m_bIsScoped") && (!strcmp(weapon, "awp", false) || !strcmp(weapon, "ssg08", false)))	{
			bool HS = event.GetBool("headshot");
			int value;
			if((value = HS ? g_iHSNoScopeValue : g_iNoScopeValue) < 0)	LogError("[Bscope] - Invalid value");
			
			value = Shop_GiveClientCredits(attacker, value, (g_bMultiCredits) ? CREDITS_BY_NATIVE : IGNORE_FORWARD_HOOK);
			PrintToChat(attacker, "\x03[SHOP] - \x04Вы получили \x03%i \x04кредитов за убийство без прицела%s", value, (!HS) ? "!" : " в голову!");
		}	
	}
}

bool ValidPlayer(int client)	{	return	client>0 && client<=MaxClients && IsClientInGame(client) && !IsFakeClient(client);	}